;11:32 26.12.2018 not a bug: player can move from ladder
;14:39 26.12.2018 bug: gold must fall too - fixed
;14:58 26.12.2018 bug: can't fall if ladder on place -fixed
;15:11 26.12.2018 add gold and check -done
;18:04 26.12.2018 bug: level 3 an issue with ladder -fixed, check earth case
;8:43 27.12.2018 bug: gold fall after move

; routines:
;scrxy: ;calc screen,Dy,E=x
;tileadr: ;calc address,A=number,HL=address
;
;dt2: ;simple stupid hack
;drwtile: ; drawtile,HL=address,DE=screen
;mapxy: ;calc map adr,D=y,E=x,IX=address

;tout:;HL=msg adress


	device zxspectrum128
        ORG #6000
begin
;equates
;0-empty
;1-ladder
;2-gold
;3-blue block
;4-boulder
;5-wall
;6-player
vem=0
vlad=1
vgo=2
vea=3
vbo=4
vwa=5
vpl=6

; menu and choose
;	ld hl,$5800,de,$5803,bc,765:set 6,(hl):ldir
;	call tit_b
	ld hl,me1
	call tout
	call tout
	call tout
	call tout
	call tout
	
	call tout;goblinish etc

;	ld hl,mec
;	call tout
;	jr $

	ld de,0
	call mcr
;	jr $
menuk:
 ld a,$F7:in a,(#FE):and 16:jp z,mleft;5 is left
 ld a,$EF:in a,(#FE):and 4:jp z,mright;8 is right
 ld a,$EF:in a,(#FE):and 8:jp z,mup;7 is up
 ld a,$EF:in a,(#FE):and 16:jp z,mdown;6 is down
 ld a,$BF:in a,($FE):rra: jp c,menuk
 
 ld a,d
 add a,a
 add a,a
 add a,d
 add a,a
 add a,e
 ld (ln),a
; jr $
 jp gameon
;	jr $

mleft:
	ld a,e
	or a
	jp z,menuk
	ei:halt
	call mcr
	dec e
	call mcr
	call wp
	jp menuk

mright:
	ld a,e
	cp 9
	jp z,menuk
	ei:halt
	call mcr
	inc e
	call mcr
	call wp

	jp menuk
mup:
	ld a,d
	or a
	jp z,menuk
	ei:halt
	call mcr
	dec d
	call mcr
	call wp
	jp menuk

	jp menuk
mdown:
	ld a,d
	cp 4
	jp z,menuk
	ei:halt
	call mcr
	inc d
	call mcr
	call wp

	jp menuk

ma=$BF00

gameon:
	ld hl,$5800,de,$5801,bc,767,(hl),0:ldir
	call drawmap
	call bouldchk
	call drln
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
glp:
	ld de,(pxy)
;N - next level
 ld a,$7F:in a,($FE):and 8: jp z,nextlev

;R - restart
 ld a,$FB:in a,($FE):and 8: jp z,gameon
;check amount of gold
	ld hl,(goldc)
	ld a,l
	cp h
	jr nz,keyc
nextlev:
	ld a,(ln)
	inc a
	ld (ln),a
	cp 50
	jp nz,gameon
;print message
	ld hl,mec
	call tout
	jr $
keyc:
 ld a,$F7:in a,(#FE):and 16:jp z,left;5 is left
;O
 ld a,$DF:in a,(#FE):and 2:jp z,left

 ld a,$EF:in a,(#FE):and 4:jp z,right;8 is right
;P
 ld a,$DF:in a,(#FE):and 1:jp z,right

 ld a,$EF:in a,(#FE):and 8:jp z,up;7 is up
;Q
 ld a,$FB:in a,(#FE):and 1:jp z,up

 ld a,$EF:in a,(#FE):and 16:jp z,down;6 is down
;A
 ld a,$FD:in a,(#FE):and 1:jp z,down

; Fire
;0
;	ld a,$EF:in a,($FE):and 1:jp z,fireon
;;En
;	ld a,$BF:in a,($FE):and 1:jp z,fireon
;;Sp
;	ld a,$7F:in a,($FE):and 1:jp z,fireon
;;M
;	ld a,$7F:in a,($FE):and 4:jp z,fireon
	jp glp

left:
; X=0?
	ld a,e
	or a:jp z,glp
	call mapxy
	ld a,(ix-1)
	cp vem:jp z,lmove
	cp vlad:jp z,lmove
	cp vgo:jp z,lgold
	cp vea:jp z,learth
	cp vwa:jp z,glp
	cp vbo:jp nz,glp
;vbo
	ld a,e
	cp 1:jp z,glp
	ld a,(ix-2)
	cp vem:jp nz,glp
	ld(ix-1),vem
	ld(ix-2),vbo

	ld a,(ix+0)
	call tileadr
	push de
	call dt2
	pop de

	push de
	dec e,e

	ld hl,tboulder
	call dt2
	pop de
lmove:
	ei:halt

;restore place
	ld a,(ix+0)
	call tileadr
	push de
	call dt2
	pop de
	dec e
	ld (pxy),de
	ld hl,tplyr
	call dt2
;test for empty - player can fall

	ld de,(pxy)
	call mapxy
	ld a,(ix+0)
	cp vlad

	call nz,falld
;lfallpl:
;	ld de,(pxy)
;	call mapxy
;	ld a,(ix+0)
;	cp vlad
;	jp z,lnofall
;;?empty
;	ld a,(ix+11)
;	cp vem:jp nz,lnofall
;;	jr $
;;if D(y)=7?
;	ld a,d
;	cp 7
;	jp z,lnofall
;	ei:halt
;	ld a,(ix+0)
;	call tileadr
;	push de
;	call dt2
;	pop de
;	inc d
;	ld (pxy),de
;	ld hl,tplyr
;	call dt2
;	jp lfallpl
lnofall:
;	test boulder fall
	call bouldchk
	call wp
;test for collected
	call drln
	jp glp
lgold:
;	jr $
	ld hl,goldc
	inc (hl)
learth:
	ld (ix-1),vem
	jp lmove
;learth:
;	jr $
;	ld (ix-1),0
;	jp lmove


right:
; X=10?
	ld a,e
	cp 10:jp z,glp
	call mapxy
	ld a,(ix+1)
	cp vem:jp z,rmove
	cp vlad:jp z,rmove
	cp vgo:jp z,rgold
	cp vea:jp z,rearth
	cp vwa:jp z,glp
	cp vbo:jp nz,glp
;vbo
	ld a,e
	cp 9:jp z,glp
	ld a,(ix+2)
	cp vem:jp nz,glp
	ld(ix+1),vem
	ld(ix+2),vbo

	ld a,(ix+0)
	call tileadr
	push de
	call dt2
	pop de

	push de
	inc e,e

	ld hl,tboulder
	call dt2
	pop de
rmove:
	ei:halt

;restore place
	ld a,(ix+0)
	call tileadr
	push de
	call dt2
	pop de
	inc e
	ld (pxy),de
	ld hl,tplyr
	call dt2
;test for empty - player can fall

	ld de,(pxy)
	call mapxy
	ld a,(ix+0)
	cp vlad

	call nz,falld

;rfallpl:
;	ld de,(pxy)
;	call mapxy
;	ld a,(ix+0)
;	cp vlad
;	jp z,rnofall
;;?empty
;	ld a,(ix+11)
;	cp vem:jp nz,rnofall
;;	jr $
;;if D(y)=7?
;	ld a,d
;	cp 7
;	jp z,rnofall
;	ei:halt
;	ld a,(ix+0)
;	call tileadr
;	push de
;	call dt2
;	pop de
;	inc d
;	ld (pxy),de
;	ld hl,tplyr
;	call dt2
;	jp rfallpl
;rnofall:
;	test boulder fall
	call bouldchk
	call wp
;test for collected
	call drln

	jp glp
rgold:
;	jr $
	ld hl,goldc
	inc (hl)
rearth:
	ld (ix+1),vem
	jp rmove

up:
;Y=0?
;	jr $
	ld a,d
	or a:jp z,glp
;where am i?
	call mapxy
	ld a,(ix+0)
	cp vlad:jp nz,glp
;can move?
	ld a,(ix-11)
	cp vem
	jr z,move_u
	cp vlad
	jp nz,glp
;?any cases?
move_u:
	ld a,(ix+0)
	call tileadr
	push de
	call dt2
	pop de
	dec d
	ld (pxy),de
	ld hl,tplyr
	call dt2
	call bouldchk
	call wp
	call drln
	jp glp

down:
;Y=7?
	ld a,d
	cp 7
	jp z,glp
;can go down?
;	jr $
	call mapxy
	ld a,(ix+11)
	or a:jr nz,contd
	call falld
	call wp
	call drln
	jp glp
contd:
	cp vlad:jp nz,glp
;contd:
	ld a,(ix+0)
	call tileadr
	push de
	call dt2
	pop de
	inc d
	ld (pxy),de
	ld hl,tplyr
	call dt2

	call bouldchk
	call wp
	call drln
	jp glp

drln:; draw level number
	push af,bc,de,hl
	ld de,met
	ld a,(ln)
	inc a
	ld c,"0"-1
dr10:
	inc c
	sub 10
	jr nc,dr10
	add a,10
	push af
	ld a,c,(de),a:inc de
	pop af
	add a,"0"
	ld (de),a
	ld hl,mel
	call tout
	pop hl,de,bc,af
	ret
mel:
 dw $4000;1E
 db $44
met: db "00",0

falld: ; player fails
lfallpl:
	ld de,(pxy)
	call mapxy
;	ld a,(ix+0)
;?empty
	ld a,(ix+11)
	cp vem:ret nz;jp nz,lnofall
;	jr $
;if D(y)=7?
	ld a,d
	cp 7
	ret z;jp z,lnofall
	ei:halt
	ld a,(ix+0)
	call tileadr
	push de
	call dt2
	pop de
	inc d
	ld (pxy),de
	ld hl,tplyr
	call dt2
	jp lfallpl
	ret

bouldchk: ;check for boulders and move it
	push af,bc,de,hl,ix
;put plyer plase
	ld de,(pxy)
	call mapxy
	ld a,(ix+0),(bcr+1),a
	ld (ix+0),vpl
chk2:
	ld ix,ma
	ld d,0
	xor a:ld (bcv+1),a
bcy:
	ld e,0
bcx:
	ld a,(ix+0)
	cp vgo
	jp nz,isbo
;fix for gold
	ld a,(ix+11)
	cp vem
	jp nz,isbo;bcnxt
	ld a,1 ; if boulder fall,set flag next pass
	ld (bcv+1),a
	ld (ix+0),vem
	ld (ix+11),vgo
	push de
	ld hl,tempty
	call dt2
	pop de
	push de
	inc d
	ld hl,tgold;tboulder
	call dt2
	ei:halt
	pop de

isbo:
	ld a,(ix+0)
	cp vbo
	jp nz,bcnxt
;boulder found what under?
	ld a,(ix+11)
	cp vem
	jp nz,bcnxt
	ld a,1 ; if boulder fall,set flag next pass
	ld (bcv+1),a
	ld (ix+0),vem
	ld (ix+11),vbo
	push de
	ld hl,tempty
	call dt2
	pop de
	push de
	inc d
	ld hl,tboulder
	call dt2
	ei:halt
	pop de

bcnxt:
	inc ix
	inc e
	ld a,e
	cp 11
	jp nz,bcx
	inc d
	ld a,d
	cp 7
	jp nz,bcy
	
bcv: ld a,0
	or a
	jp nz,chk2
;restore old place
	ld de,(pxy)
	call mapxy
bcr: ld a,0
	ld (ix+0),a

	pop ix,hl,de,bc,af
	ret

drawmap:
;add zero map
	ld hl,ma
zm: ld (hl),0
	inc l:jr nz,zm
;go
	ld hl,(ln)
	ld h,0
	ld de,tla
	add hl,hl
	add hl,de
	
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
	ld de,ma
	ld bc,88
	ldir
drma:
;count for gold and player
	ld ix,ma
	ld hl,0;L=collected,H=number
	ld d,0; Y
ylp:
	ld e,0
xlp:
	ld a,(ix+0)
	cp vpl:jr nz,noplyr
	ld (ix+0),0
	ld (pxy),de
noplyr:
	cp vgo: jr nz,cnxt
	inc h
cnxt:
	inc ix
	inc e
	ld a,e
	cp 11
	jp nz,xlp
	inc d
	bit 3,d
	jp z,ylp
	ld (goldc),hl
;	jr $
;drawmap
	ld ix,ma
	ld de,$4000
	ld c,8

dmy:
	ld b,11
	push de
;	jr $
dmx:
	ld a,(ix+0):inc ix
	call tileadr
	
	call drwtile
;	ei:halt
	inc e,e,e
	djnz dmx
	
	pop de
	ld a,e
	add a,96
	ld e,a
	sbc a,a
	and 8
	add a,d
	ld d,a
	dec c
	jr nz,dmy

;display player
	ld a,vpl
	call tileadr
	ld de,(pxy)
	call dt2
	ret

nbde    INC D:LD A,D:AND 7:RET NZ
        LD A,E:ADD A,#20:LD E,A:RET C
        LD A,D:SUB 8:LD D,A:RET
nbhl    INC h:LD A,h:AND 7:RET NZ
        LD A,L:ADD A,#20:LD L,A:RET C
        LD A,H:SUB 8:LD H,A:RET

wk:;wait keypressed
	xor a
	in a,($fe)
	cpl
	and 31
	jr z,wk
	ret
wp: ;wait until pressed
	xor a
	in a,($FE)
	cpl
	and 31
	jr nz,wp
	ret

mapxy: ;calc map adr,D=y,E=x,IX=address
	push bc,hl
	ld l,d,h,0
	ld bc,hl
	add hl,hl;*2
	add hl,bc;*3
	add hl,hl;*6
	add hl,hl;*12
	or a:sbc hl,bc;*11
	ld c,e,b,0
	add hl,bc;x+y*11
	ld bc,ma
	add hl,bc
	push hl
	pop ix
	pop hl,bc
	ret
scrxy: ;calc screen,D=y,E=x,HL=address
	push de
	ld a,d
	add a,a
	add a,d
	ld d,a

	ld a,e
	add a,a
	add a,e
	ld e,a

		ld	hl, 4000h
		ld	a, d
		and	18h
		or	h
		ld	h, a
		ld	a, d
		and	7
		ld	d, a
		srl	d
		rr	l
		srl	d
		rr	l
		srl	d
		rr	l
		add	hl, de
	pop de
	ret
	
dt2: ;simple stupid hack
	ld a,11
	sub e
	ld b,a
	push hl
	call scrxy
	pop de
	ex de,hl
drwtile: ; drawtile,HL=address,DE=screen
	push bc,de
	ld a,(hl):inc hl ; get tile color
	ld (dtcv+1),a

	ld a,24
dtlp:
	exa
	push de
	ldi:ldi
;extra byte
	ld a,e
	and 31
	;cp 31
	jr nz,dtpb
	inc hl
	jr skpb
dtpb:
	ldi
skpb:
	pop de
	call nbde
	exa
	dec a
	jr nz,dtlp
;put color
	pop de

;: DE=
;: HL= 
;$40=010 00 000
;$48=010 01 000
;$50=010 10 000

;$58=010110 00
;$59=010110 01
;$5A=010110 10
;	jr $
	ld a,d
	and %000111000
	rra
	rra
	rra
	add a,$58
	ld h,a
	ld l,e

	pop bc
	ld a,b
	push bc,de
dtcv: ld d,7
	ld e,a

	ld a,3
dtcy:
	exa
	push hl
dtcx:
	ld (hl),d:inc hl
	ld (hl),d:inc hl

	ld a,e
	cp 1
	jr z,dtcn
	ld (hl),d:inc hl
dtcn:
	pop hl
	ld bc,32:add hl,bc
	exa
	dec a:jp nz,dtcy
	
	pop de,bc
	ret
tileadr: ;calc address,A=number,HL=address
	push bc
	ld l,a,h,0
	ld bc,ta
	add hl,hl
	add hl,bc
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
	
;	inc hl;skip color
	pop bc
	ret
;;;;;;;; M E N U ;;;;;;;;
mcr: ;cursor,D=y,E=x
	ld l,d,h,0,b,h
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	ld a,e
	add a,a
	add a,e
	ld c,a
	add hl,bc
	ld bc,$5a21
	add hl,bc
	ld a,(hl):xor 8:ld (hl),a:inc l
	ld a,(hl):xor 8:ld (hl),a:inc l
	ld a,(hl):xor 8:ld (hl),a:inc l
	ld a,(hl):xor 8:ld (hl),a:inc l
	ret
mec:
	dw $484C
	db $45
	db "The End",0
me1:
;0
 dw $5000+32+1
 db $47
 db " 01 02 03 04 05 06 07 08 09 10",0
;1
 dw $5000+32*2+1
 db $47
 db " 11 12 13 14 15 16 17 18 19 20",0
;2
 dw $5000+32*3+1
 db $47
 db " 21 22 23 24 25 26 27 28 29 30",0
;3
 dw $5000+32*4+1
 db $47
 db " 31 32 33 34 35 36 37 38 39 40",0
;4
 dw $5000+32*5+1
 db $47
 db " 41 42 43 44 45 46 47 48 49 50",0

 dw $5000+32*7+8+1
 db $44
 db "g0blinish,2o18",0
tout:;HL=msg adress
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl

	ld a,(hl) ; color
	inc hl
	ld (ct+1),a
telp:
	ld a,(hl)
	inc hl
	or a
	ret z
	push hl
	ld l,a
	ld h,0
	add hl,hl
	add hl,hl
	add hl,hl
	ld bc,fnt-256
	add hl,bc
	
	ld b,8
	push de
chrlp:
	ld a,(hl)
	ld (de),a
	inc hl
	inc d
	djnz chrlp

	pop de

;$40=010 00 000
;$48=010 01 000
;$50=010 10 000

;$58=010110 00
;$59=010110 01
;$5A=010110 10
	ld a,d
	and %000111000
	rra
	rra
	rra
	add a,$58
	ld h,a
	ld l,e
ct: ld (hl),0

	inc e
	pop hl
	jp telp
	ret

;****************************** V A R S ******************************
ln: db 03;level number
pxy: dw 0
goldc: db 0 ; gold collected
goldn: db 0 ; gold number
;****************************** D A T A ******************************
ta:
 dw tempty,tladder,tgold,tearth,tboulder,twall,tplyr
;0-empty
tempty:
 db 7 ;color
 ds 72
;1-ladder
tladder:
 db 5
 incbin "tladder.bin"
;2-gold
tgold:
 db 6
 incbin "tgold1.bin"
;3-blue block
tearth:
 db 1
 incbin "tearth.bin"
;4-boulder
tboulder:
 db 2
 incbin "tboulder1.bin"
;5-wall
twall:
 db 3
 incbin "twall.bin"
;6-player
tplyr:
 db 7
 incbin "tplyr.bin"

fnt:incbin "Metallion05.fnt"
;00040000000
;15545055551
;10040500001
;10630000001
;55550500001
;00005000001
;20000000041
;55505550555
tla:
 dw lev1,lev2,lev3,lev4,lev5,lev6,lev7,lev8,lev9,lev10
 dw lev11,lev12,lev13,lev14,lev15,lev16,lev17,lev18,lev19,lev20
 dw lev21,lev22,lev23,lev24,lev25,lev26,lev27,lev28,lev29,lev30
 dw lev31,lev32,lev33,lev34,lev35,lev36,lev37,lev38,lev39,lev40
 dw lev41,lev42,lev43,lev44,lev45,lev46,lev47,lev48,lev49,lev50
	include "levels.inc"
end

	org $B000
tit_b:
	ld hl,$5800,de,$5801,bc,767,(hl),l:ldir

	ld hl,tbin;23x56
	ld de,$4800+3+2
	ld a,56
tlp:
	exa
	push de
	ld bc,23
	ldir
	pop de
	 INC D:LD A,D
	 AND 7:jr nz,$+12
	 LD A,E:ADD A,#20:LD E,A:jr c,$+6
	 LD A,D:SUB 8:LD D,A
	 exa
	 dec a
	 jr nz,tlp
;attributes
	ld hl,$5901-32+2
	ld a,7+2
atlp:
	push hl
	ld de,hl
	inc de
	ld (hl),2*8+7+64
	ld bc,27-2
	ldir
	pop hl
	ld bc,32
	add hl,bc
	dec a
	jr nz,atlp
	ret
tbin: incbin "pitmlo.bin"
tit_e:
	display end
	display /d,end-begin
	savesna "pit.sna",begin
	savebin "game.code",begin,end-begin
	savebin "title.code",tit_b,tit_e-tit_b
